# DarContact: Fran�is Dupoux <fdupoux@partimage.org>

Summary: A partition imaging utility, much like Ghost. Hacked to support Mondo Rescue.
Name: partimagehack
Version: 0.6.2
Release: 1
License: GPL
Group: Applications/System
URL: http://www.partimage.org

Packager: Hugo Rabson <hugorabson@msn.com>
Vendor: Mondo Rescue, http://www.mondorescue.org/

Source: http://www.mondorescue.org/download/%{name}-%{version}.tgz
BuildRoot: %{_tmppath}/root-%{name}-%{version}
Prefix: %{_prefix}

BuildRequires: parted-devel, newt-devel, libmcrypt-devel

%description
Partition Image is a Linux/UNIX partition imaging utility: it saves all used
blocks in a partition to an image file. This image file can be compressed
using gzip or bzip2 compression to save space, and even split into multiple
files to be copied to movable media such as Zip disks or CD-R.

Partimagehack is partimage with a small patch added, to permit Mondo Rescue
to use partimage to backup NTFS and other non-Linux partitions.

%package static
Summary: A partition imaging utility, much like Ghost. Hacked to support Mondo Rescue.
Group: Applications/System

%description static
Partition Image is a Linux/UNIX partition imaging utility: it saves all used
blocks in a partition to an image file. This image file can be compressed
using gzip or bzip2 compression to save space, and even split into multiple
files to be copied to movable media such as Zip disks or CD-R.

Partimagehack is partimage with a small patch added, to permit Mondo Rescue
to use partimage to backup NTFS and other non-Linux partitions.

This package contains a static compiled binary.

%package server
Summary: The server part of a partition imaging utility, much like Ghost.
Group: System Environment/Daemons

%description server
Partition Image is a Linux/UNIX partition imaging utility: it saves all used
blocks in a partition to an image file. This image file can be compressed
using gzip or bzip2 compression to save space, and even split into multiple
files to be copied to movable media such as Zip disks or CD-R.

Partimagehack is partimage with a small patch added, to permit Mondo Rescue
to use partimage to backup NTFS and other non-Linux partitions.

This package contains the server daemon for remote imaging.

%prep
%setup

### FIXME: Disable chowning of files
%{__perl} -pi.orig -e 's|^\tchown partimag\.root.*$|\\|' Makefile.in

%{__cat} <<EOF >partimagedhack.sysconfig
### See partimagedhack --help for more information on these options.
###

#OPTIONS="--port=1234 --chroot %{_localstatedir}/partimagedhack --nologin"
EOF

%{__cat} <<'EOF' >partimagedhack.sysv
#!/bin/bash
#
# Init file for partimagehack daemon
#
# Written by Dag Wieers <dag@wieers.com>.
#
# chkconfig: - 80 20
# description: partimagedhack is a partition imaging daemon.
#
# processname: partimagedhack
# config: %{_sysconfdir}/sysconfig/partimagedhack
# pidfile: %{_localstatedir}/lock/subsys/partimagedhack

source %{_initrddir}/functions
source %{_sysconfdir}/sysconfig/network

### Check that networking is up.
[ "${NETWORKING}" == "no" ] && exit 0

[ -x %{_sbindir}/partimagedhack ] || exit 1
[ -r %{_sysconfdir}/sysconfig/partimagedhack ] || exit 1

### Default variables
SYSCONFIG="%{_sysconfdir}/sysconfig/partimagedhack"
OPTIONS=""

### Read configuration
[ -r "$SYSCONFIG" ] && source "$SYSCONFIG"
  
RETVAL=0
prog="partimagedhack"
desc="Partition imaging daemon"

start() {
        echo -n $"Starting $desc ($prog): "
	cd %{_localstatedir}/partimagedhack
        daemon %{_sbindir}/$prog --daemon $OPTIONS
        RETVAL=$?
        echo
        [ $RETVAL -eq 0 ] && touch %{_localstatedir}/lock/subsys/$prog
        return $RETVAL
}

stop() {
        echo -n $"Shutting down $desc ($prog): "
        killproc $prog
        RETVAL=$?
        echo
        [ $RETVAL -eq 0 ] && rm -f %{_localstatedir}/lock/subsys/$prog
        return $RETVAL
}

restart() {
        stop
        start
}

reload() {
        echo -n $"Reloading $desc ($prog): "
        killproc $prog -HUP
        RETVAL=$?
        echo
        return $RETVAL
}

case "$1" in
  start)
        start
        ;;
  stop)
        stop
        ;;
  restart)
        restart
        ;;
  reload)
        reload
        ;;
  condrestart)
        [ -e %{_localstatedir}/lock/subsys/$prog ] && restart
        RETVAL=$?
        ;;
  status)
        status $prog
        RETVAL=$?
        ;;
  *)
        echo $"Usage: $0 {start|stop|restart|reload|condrestart|status}"
        RETVAL=1
esac

exit $RETVAL
EOF

%{__cat} <<EOF >partimagedhack.logrotate
%{_localstatedir}/log/partimagedhack.log {
        missingok
        copytruncate
        notifempty
}
EOF

%build
%configure \
	--program-prefix="%{?_program_prefix}" \
	--with-log-dir="%{_localstatedir}/log" \
	--disable-dependency-tracking \
	--disable-ssl \
	--enable-gui-text \
	--enable-gui-newt \
	--enable-all-static 
%{__make} %{?_smp_mflags}
%{__mv} -f src/client/partimagehack partimagehack-static
%{__rm} -f src/server/partimagedhack

%configure \
	--program-prefix="%{?_program_prefix}" \
	--with-log-dir="%{_localstatedir}/log" \
	--disable-dependency-tracking \
	--disable-ssl \
	--with-xinerama \
	--enable-gui-text \
	--enable-gui-newt \
	--enable-gui-qt
%{__make} %{?_smp_mflags}

%install
%{__rm} -rf %{buildroot}
%makeinstall
%find_lang partimagehack
# %{name}

%{__install} -m0755 partimagehack-static %{buildroot}%{_sbindir}

%{__install} -d -m0755 %{buildroot}%{_initrddir} \
			%{buildroot}%{_sysconfdir}/logrotate.d/ \
			%{buildroot}%{_sysconfdir}/sysconfig/ \
			%{buildroot}%{_localstatedir}/partimagedhack/ \
			%{buildroot}%{_localstatedir}/log/
%{__install} -m0755 partimagedhack.sysv %{buildroot}%{_initrddir}/partimagedhack
%{__install} -m0644 partimagedhack.logrotate %{buildroot}%{_sysconfdir}/logrotate.d/partimagedhack
%{__install} -m0644 partimagedhack.sysconfig %{buildroot}%{_sysconfdir}/sysconfig/partimagedhack

touch %{buildroot}%{_localstatedir}/log/partimagedhack.log

### Clean up buildroot
%{__rm} -rf %{buildroot}%{_datadir}/info/

%pre server
/usr/sbin/useradd -M -r -s "/sbin/nologin" -d "%{_localstatedir}/partimagedhack" partimag &>/dev/null || :
/usr/sbin/usermod -s "/sbin/nologin" -d "%{_localstatedir}/partimagedhack" partimag &>/dev/null || :

%post server
if [ $1 -eq 1 ]; then
        /sbin/chkconfig --add partimagedhack
fi
/sbin/service partimagedhack condrestart &>/dev/null || :

%preun server
if [ $1 -eq 0 ]; then
        /sbin/service partimagedhack stop &>/dev/null || :
        /sbin/chkconfig --del partimagedhack
fi

%postun server
/sbin/service partimagedhack condrestart &>/dev/null || :

%clean
%{__rm} -rf %{buildroot}

%files -f %{name}.lang
%defattr(-, root, root, 0755)
%doc AUTHORS BOOT* BUGS ChangeLog COPYING FUTURE README SURVEY THANKS TODO
%{_sbindir}/partimagehack

%files server
%defattr(-, root, root, 0755)
%doc README.partimagedhack
%config(noreplace) %{_initrddir}/*
%config(noreplace) %{_sysconfdir}/logrotate.d/*
%config(noreplace) %{_sysconfdir}/sysconfig/*
%{_sbindir}/partimagedhack
%defattr(-, partimag, partimag, 0755)
%config(noreplace) %{_sysconfdir}/partimagedhack/
%dir %{_localstatedir}/partimagedhack/
%ghost %{_localstatedir}/log/partimagedhack.log

%files static
%defattr(-, root, root, 0755)
%{_sbindir}/partimagehack-static

%changelog
* Sun Sep 07 2003 Hugo Rabson <hugorabson@msn.com> - 0.6.2-1
- rolled as partimagehack

* Wed Jul 30 2003 Dag Wieers <dag@wieers.com> - 0.6.2-0
- Initial package. (using DAR)
